searchNodes=[{"type":"module","title":"ExRabbitPool","doc":"","ref":"ExRabbitPool.html"},{"type":"function","title":"ExRabbitPool.checkin_channel/2","doc":"Puts back a RabbitMQ channel into its corresponding connection worker","ref":"ExRabbitPool.html#checkin_channel/2"},{"type":"function","title":"ExRabbitPool.checkout_channel/1","doc":"Gets a RabbitMQ channel out of a connection worker","ref":"ExRabbitPool.html#checkout_channel/1"},{"type":"function","title":"ExRabbitPool.create_queue_with_bind/5","doc":"","ref":"ExRabbitPool.html#create_queue_with_bind/5"},{"type":"function","title":"ExRabbitPool.get_connection/1","doc":"Gets a connection from a connection worker so any client can exec commands manually","ref":"ExRabbitPool.html#get_connection/1"},{"type":"function","title":"ExRabbitPool.get_connection_worker/1","doc":"Retrieve a connection worker - we don't care about isolating access to each worker - we use a pool purely in order to spread load (pool config strategy :fifo)","ref":"ExRabbitPool.html#get_connection_worker/1"},{"type":"function","title":"ExRabbitPool.with_channel/2","doc":"Executes function f in the context of a channel, takes a connection worker out of the pool, put that connection worker back into the pool so any other concurrent client can have access to it, checks out a channel out of the worker's channel pool, executes the function with the result of the checkout and finally puts the channel back into the worker's pool.","ref":"ExRabbitPool.html#with_channel/2"},{"type":"type","title":"ExRabbitPool.f/0","doc":"","ref":"ExRabbitPool.html#t:f/0"},{"type":"behaviour","title":"ExRabbitPool.Clients.Adapter","doc":"","ref":"ExRabbitPool.Clients.Adapter.html"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.ack/3","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:ack/3"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.cancel_consume/3","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:cancel_consume/3"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.close_channel/1","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:close_channel/1"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.close_connection/1","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:close_connection/1"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.consume/4","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:consume/4"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.declare_exchange/3","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:declare_exchange/3"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.declare_queue/3","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:declare_queue/3"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.open_channel/1","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:open_channel/1"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.open_connection/1","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:open_connection/1"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.publish/5","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:publish/5"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.qos/2","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:qos/2"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.queue_bind/4","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:queue_bind/4"},{"type":"callback","title":"ExRabbitPool.Clients.Adapter.reject/3","doc":"","ref":"ExRabbitPool.Clients.Adapter.html#c:reject/3"},{"type":"behaviour","title":"ExRabbitPool.Consumer","doc":"","ref":"ExRabbitPool.Consumer.html"},{"type":"callback","title":"ExRabbitPool.Consumer.basic_cancel/3","doc":"","ref":"ExRabbitPool.Consumer.html#c:basic_cancel/3"},{"type":"callback","title":"ExRabbitPool.Consumer.basic_cancel_ok/2","doc":"","ref":"ExRabbitPool.Consumer.html#c:basic_cancel_ok/2"},{"type":"callback","title":"ExRabbitPool.Consumer.basic_consume_ok/2","doc":"","ref":"ExRabbitPool.Consumer.html#c:basic_consume_ok/2"},{"type":"callback","title":"ExRabbitPool.Consumer.basic_deliver/3","doc":"","ref":"ExRabbitPool.Consumer.html#c:basic_deliver/3"},{"type":"type","title":"ExRabbitPool.Consumer.meta/0","doc":"","ref":"ExRabbitPool.Consumer.html#t:meta/0"},{"type":"type","title":"ExRabbitPool.Consumer.no_wait/0","doc":"","ref":"ExRabbitPool.Consumer.html#t:no_wait/0"},{"type":"type","title":"ExRabbitPool.Consumer.reason/0","doc":"","ref":"ExRabbitPool.Consumer.html#t:reason/0"},{"type":"module","title":"ExRabbitPool.Consumer.State","doc":"RabbitMQ Consumer Worker State. State attributes: :pool_id - the name of the connection pool to RabbitMQ :channel - the RabbitMQ channel for consuming new messages :monitor - a monitor for handling channel crashes :queue - the name of the queue to consume :consumer_tag - the consumer tag assigned by RabbitMQ :config - the consumer configuration attributes :adapter - the RabbitMQ client to use","ref":"ExRabbitPool.Consumer.State.html"},{"type":"type","title":"ExRabbitPool.Consumer.State.t/0","doc":"Consumer State Type","ref":"ExRabbitPool.Consumer.State.html#t:t/0"},{"type":"module","title":"ExRabbitPool.FakeRabbitMQ","doc":"","ref":"ExRabbitPool.FakeRabbitMQ.html"},{"type":"module","title":"ExRabbitPool.PoolSupervisor","doc":"","ref":"ExRabbitPool.PoolSupervisor.html"},{"type":"function","title":"ExRabbitPool.PoolSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExRabbitPool.PoolSupervisor.html#child_spec/1"},{"type":"function","title":"ExRabbitPool.PoolSupervisor.start_link/1","doc":"","ref":"ExRabbitPool.PoolSupervisor.html#start_link/1"},{"type":"function","title":"ExRabbitPool.PoolSupervisor.start_link/2","doc":"","ref":"ExRabbitPool.PoolSupervisor.html#start_link/2"},{"type":"type","title":"ExRabbitPool.PoolSupervisor.config/0","doc":"","ref":"ExRabbitPool.PoolSupervisor.html#t:config/0"},{"type":"module","title":"ExRabbitPool.RabbitMQ","doc":"","ref":"ExRabbitPool.RabbitMQ.html"},{"type":"module","title":"ExRabbitPool.Worker.RabbitConnection","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.checkin_channel/2","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html#checkin_channel/2"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.checkout_channel/1","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html#checkout_channel/1"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExRabbitPool.Worker.RabbitConnection.html#child_spec/1"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.create_channel/1","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html#create_channel/1"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.get_connection/1","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html#get_connection/1"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.init/1","doc":"Traps exits so all the linked connection and multiplexed channels can be restarted by this worker. Triggers an async connection but making sure future calls need to wait for the connection to happen before them. config is the rabbitmq config settings","ref":"ExRabbitPool.Worker.RabbitConnection.html#init/1"},{"type":"function","title":"ExRabbitPool.Worker.RabbitConnection.start_link/1","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.html#start_link/1"},{"type":"module","title":"ExRabbitPool.Worker.RabbitConnection.State","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.State.html"},{"type":"type","title":"ExRabbitPool.Worker.RabbitConnection.State.config/0","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.State.html#t:config/0"},{"type":"type","title":"ExRabbitPool.Worker.RabbitConnection.State.t/0","doc":"","ref":"ExRabbitPool.Worker.RabbitConnection.State.html#t:t/0"},{"type":"module","title":"ExRabbitPool.Worker.SetupQueue","doc":"","ref":"ExRabbitPool.Worker.SetupQueue.html"},{"type":"function","title":"ExRabbitPool.Worker.SetupQueue.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExRabbitPool.Worker.SetupQueue.html#child_spec/1"},{"type":"function","title":"ExRabbitPool.Worker.SetupQueue.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"ExRabbitPool.Worker.SetupQueue.html#init/1"},{"type":"function","title":"ExRabbitPool.Worker.SetupQueue.start_link/1","doc":"","ref":"ExRabbitPool.Worker.SetupQueue.html#start_link/1"},{"type":"extras","title":"current_rabbit_pool","doc":"In the multiverse multiple ex_rabbit_pool may exist, ours is the currently updated one. See https://github.com/esl/ex_rabbit_pool/issues/86 ex_rabbit_pool A RabbitMQ connection pooling library written in Elixir","ref":"readme.html"},{"type":"extras","title":"current_rabbit_pool - Is this lib still maintained?","doc":"Yes!, but this is not yet another amqp framework, the whole purpose of this lib is to implement just the pooling side of rabbitmq connections which is now feature complete , we still need to finish some TODOs and improvements inside the lib but we are not planning to add any new features to it, but if you think there is something left in this regards please don't hesitate to create a ticket so we can discuss it.","ref":"readme.html#is-this-lib-still-maintained"},{"type":"extras","title":"current_rabbit_pool - Installation","doc":"If available in Hex , the package can be installed by adding current_rabbit_pool to your list of dependencies in mix.exs : def deps do [ { :current_rabbit_pool , &quot;~&gt; 1.1&quot; } ] end HexDocs Hex.pm","ref":"readme.html#installation"},{"type":"extras","title":"current_rabbit_pool - General Overview","doc":"ex_rabbit_pool creates a pool or many pools of connections to RabbitMQ, we don't care about isolating access to each worker that's why we use a pool purely in order to spread load (pool config strategy :fifo) each connection worker traps exits and links the connection process to it each connection worker creates a pool of channels and links them to it when a client checks out a channel out of the pool the connection worker monitors that client to return the channel into it in case of a crash in case you don't want to pool channels, you can disable this feature by setting the channels number to 0, then you can create channels on demand","ref":"readme.html#general-overview"},{"type":"extras","title":"current_rabbit_pool - High Level Architecture","doc":"When starting a connection worker : We start a pool of multiplexed channels to RabbitMQ Store the channel pool to the connection workers state (we can move this later to ets). Then: The connection worker traps exists of RabbitMQ channels - which means that : If a channel crashes, the connection worker is going to be able to start another channel If a connection to RabbitMQ crashes we are going to be able to restart that connection, remove all crashed channels and then restart them with a new connection; Also: We are able to easily: Monitor clients accessing channels, Queue and dequeue channels from the pool in order to make them accessible to one client at a time reducing the potential for race conditions.","ref":"readme.html#high-level-architecture"},{"type":"extras","title":"current_rabbit_pool - Setup RabbitMQ with docker","doc":"# pull RabbitMQ image from docker $&gt; docker pull rabbitmq:3.7.7-management # run docker in background # name the container # remove container if already exists # attach default port between the container and your laptop # attach default management port between the container and your laptop # start rabbitmq with management console $&gt; docker run --detach --rm --hostname bugs-bunny --name roger_rabbit -p 5672:5672 -p 15672:15672 rabbitmq:3.7.7-management # if you need to stop the container $&gt; docker stop roger_rabbit # if you need to remove the container manually $&gt; docker container rm roger_rabbit","ref":"readme.html#setup-rabbitmq-with-docker"},{"type":"extras","title":"current_rabbit_pool - Supervision hierarchy","doc":"","ref":"readme.html#supervision-hierarchy"},{"type":"extras","title":"current_rabbit_pool - Setting Up Multiple Connection pools","doc":"It’s a good practice to not have consumers and producers on the same connection (since if something goes to flow mode the connection will be blocked and consumers won’t be able to help RabbitMQ to offload all the messages), that's why we support setting up multiple queues thanks to poolboy rabbitmq_config = [ channels : 1 , ] # Connection Pool Configuration producers_conn_pool = [ name : { :local , :producers_pool } , worker_module : ExRabbitPool.Worker.RabbitConnection , size : 1 , max_overflow : 0 ] consumers_conn_pool = [ name : { :local , :consumers_pool } , worker_module : ExRabbitPool.Worker.RabbitConnection , size : 1 , max_overflow : 0 ] ExRabbitPool.PoolSupervisor . start_link ( rabbitmq_config : rabbitmq_config , connection_pools : [ producers_conn_pool , consumers_conn_pool ] ) producers_conn = ExRabbitPool . get_connection ( :producers_pool ) consumers_conn = ExRabbitPool . get_connection ( :consumers_pool ) ExRabbitPool . with_channel ( :producers_pool , fn { :ok , channel } -&gt; ... end ) ExRabbitPool . with_channel ( :consumers_pool , fn { :ok , channel } -&gt; ... end )","ref":"readme.html#setting-up-multiple-connection-pools"},{"type":"extras","title":"current_rabbit_pool - Setting Up Queues on Start Up","doc":"We support setting up queues when starting up the supervision tree via ExRabbitPool.Worker.SetupQueue , right now it doesn't handle reconnect logic for you, so if you have a reconnection and you are working with auto_delete: true queues, you need to handle this case by your self (re-create those queues because if connectivity drops, auto_delete: true queues are going to be de deleted automatically and if you try to use one of them you would have an error as the queue no longer exist). Images are taken from RabbitMQ Tutorials","ref":"readme.html#setting-up-queues-on-start-up"},{"type":"extras","title":"current_rabbit_pool - Setting up a direct exchange with bindings","doc":"rabbitmq_config = [ ... , # Basic Rabbit Connection Configuration ] queues_config = [ queues : [ [ queue_name : &quot;Q1&quot; , exchange : &quot;X&quot; , queue_options : [ ] , exchange_options : [ ] , bind_options : [ routing_key : &quot;orange&quot; ] ] , [ queue_name : &quot;Q2&quot; , exchange : &quot;X&quot; , queue_options : [ ] , exchange_options : [ ] , bind_options : [ routing_key : &quot;black&quot; ] ] , [ queue_name : &quot;Q2&quot; , exchange : &quot;X&quot; , queue_options : [ ] , exchange_options : [ ] , bind_options : [ routing_key : &quot;green&quot; ] ] ] ] # Basic Connection Pool Configuration rabbitmq_conn_pool = [ ... ] ExRabbitPool.PoolSupervisor . start_link ( rabbitmq_config : rabbitmq_config , connection_pools : [ rabbitmq_conn_pool ] ) ExRabbitPool.Worker.SetupQueue . start_link ( { pool_id , queues_config } )","ref":"readme.html#setting-up-a-direct-exchange-with-bindings"},{"type":"extras","title":"current_rabbit_pool - Setting up a direct exchange with multiple bindings","doc":"rabbitmq_config = [ ... , # Basic Rabbit Connection Configuration ] queues_config = [ queues : [ [ queue_name : &quot;Q1&quot; , exchange : &quot;X&quot; , queue_options : [ ] , exchange_options : [ ] , bind_options : [ routing_key : &quot;black&quot; ] ] , [ queue_name : &quot;Q2&quot; , exchange : &quot;X&quot; , queue_options : [ ] , exchange_options : [ ] , bind_options : [ routing_key : &quot;black&quot; ] ] ] ] # Basic Connection Pool Configuration rabbitmq_conn_pool = [ ... ] ExRabbitPool.PoolSupervisor . start_link ( rabbitmq_config : rabbitmq_config , connection_pools : [ rabbitmq_conn_pool ] ) ExRabbitPool.Worker.SetupQueue . start_link ( { pool_id , queues_config } )","ref":"readme.html#setting-up-a-direct-exchange-with-multiple-bindings"},{"type":"extras","title":"current_rabbit_pool - EchoConsumer - Example","doc":"In the examples directory you are going to find an implementation of a RabbitMQ consumer using the library, all you need to do is, starting RabbitMQ with docker , and copy/paste the following code into the iex console. What it does is, setup the connection pool, setup the queues, exchanges and bindings to use, start the consumer and finally publish some messages to the exchange so the consumer can echo it. rabbitmq_config = [ channels : 2 ] rabbitmq_conn_pool = [ name : { :local , :connection_pool } , worker_module : ExRabbitPool.Worker.RabbitConnection , size : 1 , max_overflow : 0 ] { :ok , pid } = ExRabbitPool.PoolSupervisor . start_link ( rabbitmq_config : rabbitmq_config , connection_pools : [ rabbitmq_conn_pool ] ) queue = &quot;ex_rabbit_pool&quot; exchange = &quot;my_exchange&quot; routing_key = &quot;example&quot; ExRabbitPool . with_channel ( :connection_pool , fn { :ok , channel } -&gt; { :ok , _ } = AMQP.Queue . declare ( channel , queue , auto_delete : true , exclusive : true ) :ok = AMQP.Exchange . declare ( channel , exchange , :direct , auto_delete : true , exclusive : true ) :ok = AMQP.Queue . bind ( channel , queue , exchange , routing_key : routing_key ) end ) { :ok , consumer_pid } = Example.EchoConsumer . start_link ( pool_id : :connection_pool , queue : queue ) ExRabbitPool . with_channel ( :connection_pool , fn { :ok , channel } -&gt; :ok = AMQP.Basic . publish ( channel , exchange , routing_key , &quot;Hello World!&quot; ) :ok = AMQP.Basic . publish ( channel , exchange , routing_key , &quot;Hell Yeah!&quot; ) end )","ref":"readme.html#echoconsumer-example"}]